#include "5ro14_husky_controller/MyController.hpp"
#include <cmath>

namespace husky_controller
{
  MyController::MyController(ros::NodeHandle &nodeHandle) :
      m_nodeHandle(&nodeHandle)
  {
    std::string scanTopicName;
    if (!m_nodeHandle->getParam("scan_topic_name", scanTopicName))
    {
      ROS_ERROR("Load scan_topic_name param fail!!");
      return;
    }

    int scanTopicQueueSize;
    if (!m_nodeHandle->getParam("scan_topic_queue_size", scanTopicQueueSize))
    {
      ROS_ERROR("Load scan_topic_queue_size param fail!!");
      return;
    }

    m_laserScanSubscriber = m_nodeHandle->subscribe(scanTopicName, scanTopicQueueSize, &MyController::laserCallBack, this);
  }

  
  void MyController::laserCallBack(const sensor_msgs::LaserScan::ConstPtr &msg)
  {
    float minVal = msg->range_max;

    for (unsigned int i = 0; i < msg->ranges.size(); ++i)
    {
      if (std::isnormal(msg->ranges[i]))
      {
        if (minVal > msg->ranges[i])
        {
          minVal = msg->ranges[i];
        }
      }
    }

    ROS_INFO_STREAM(minVal);
  }

} /* namespace */
